%% Georeferenzierung 
% 
clear all;
imdata = imread('HohTs.jpg');
image(imdata)
axis off
axis image
hold on


%% Zuordnung Pixel - Punkte
% 9 Referenzpunkte sind gegeben. Format Datensatz:
% Pixel x | Pixel y | Geogr. Länge | Geogr. Breite
data=[    369         2299       12.983       47.417
         1143         2299           13       47.417
         1917         2299       13.017       47.417
          372         1159       12.983       47.433
         1146         1160           13       47.433
         1919         1160       13.017       47.433
          372           17       12.983        47.45
         1147           17           13        47.45
         1921           18       13.017        47.45
    ];

%% Datenmodell Pixel x = cx1 + cx2*long + cx3*lat
bx = data(:,1);
A = [ones(size(bx)) data(:,3) data(:,4)];
cx = A\bx;

%% Datenmodell Pixel y = cy1 + cy2*long + cy3*lat
% Matrix A bleibt gleich, nur rechte Seite ist anders. (Man könnte also die
% x- und die y-Anpassung in einem einzigen Befehl programmieren, aber der
% Übersichtlichkeit halber sind beide Lösungen getrennt implementiert.)
by = data(:,2);
cy = A\by;

% Fehler in Pixel bei der Anpassung
errx=abs(A*cx-bx);
erry=abs(A*cy-by);

%% Wegpunkte einlesen und geogr. Koordinaten in Pixel umrechnen
load trackpnts.mat;
% das ist eine lange Liste von Längen- und Breitendaten: 
% Format: Wertepaare [lat lon]
%
% latlon = [
%    12.9817   47.4140
%    12.9818   47.4139
%    12.9817   47.4139
%    12.9817   47.4139
%    12.9817   47.4140
%    ...        ...    ]

% Die Auswertung des Datenmodells x = cx1 + cx2*lon  + cx3*lat könnte man
% in einer Schleife für jedes lat-lon-Wertepaar abarbeiten. Eleganter hier
% in Matrixform. Die Matrix A ist analog zur Datenmatrix oben aufgebaut.

A = [ones(length(latlon),1), latlon];
pxpy = A*[cx, cy];

%% Einzeichnen der Datenpunkte in der Abbildung
plot(pxpy(:,1),pxpy(:,2),'r','LineWidth',3)
hold off

%axis([1600 2400 200 1100])
%print -r600 -djpeg HoheTorscharte